%find Bnodes and r (and maybe n)
function [Bnode,r,ntot] = Bnodes(f,n)

[M,N] = size(f);
ish = floor(max(M,N)/42);

%major fudge factor here
crat = .42;  %increase if we get too many boundary nodes

if (nargin < 2)
   n = M;
end

rat = .99; %cutoff ratio
pad = 6;
r = 0; %starting radius - .5

%just work with points on the graph
p = find(f==1);

g = ones(length(p),1);

while (max(max(g))> rat)
   r = r + 1; %scale r to match boundary nodes
   for k = 1:length(p)
      j = floor((p(k)-1)/M)+1; %column
      i = p(k) - M*(j-1); %row      
      g(k) = mean(mean( f(i-r:i+r,j-r:j+r) ));
   end   
end
if (nargin < 2)
   %crat = (6*r+2)/((2*r+1)^2); %fudge factor alert
   %crat = (r^2 + 3*r+2)/((2*r+1)^2); %fudge factor alert
   %crat = .42;  %increase if we get too many boundary nodes (default)
else
   crat = .1;
end

%make sure we find something
q = 0;
while (q == 0)
   Ig = find(g>crat);
   [sg, Isg] = sort(g(Ig));
   q = length(sg);
   crat = crat*.95;
end

if (n == 0)
   Bnode = [];
   ntot = 0;
else
   bind = 1;
   Bnode(bind).ind = p(Ig(Isg(q)));
   Bnode(bind).j = floor((p(Ig(Isg(q)))-1)/M)+1;
   Bnode(bind).i = p(Ig(Isg(q))) - M*(Bnode(bind).j-1);
   ntot = 1;   
   
   for q = length(sg)-1:-1:1      
      temp.ind = p(Ig(Isg(q)));
      temp.j = floor((p(Ig(Isg(q)))-1)/M)+1;
      temp.i = p(Ig(Isg(q))) - M*(temp.j-1);
      
      dist2 = zeros(length(Bnode),1);
      for w = 1:length(dist2)
         dist2(w) = (temp.i-Bnode(w).i)^2 + (temp.j-Bnode(w).j)^2;
      end
      if ( min(dist2)>(2*r+pad)^2 & ntot<n)
         bind = bind + 1;
         Bnode(bind).ind = temp.ind;
         Bnode(bind).j = temp.j;
         Bnode(bind).i = temp.i;
         ntot = ntot + 1;
      end
   end
   
   %order the boundary nodes
   for k = 1:length(Bnode)
      ind(k) = Bnode(k).ind;
   end
   [sind, Isind] = sort(ind);
   for k = 1:length(Bnode)
      obnode(k) = Bnode(Isind(k));
   end
   Bnode = obnode;
   
   %visualization
   figure(42)
   for (t = 1:length(Bnode))
      hold on   
      rectangle('Position',[Bnode(t).j-ish,Bnode(t).i-ish,2*ish,2*ish],'Curvature',[1,1],...
         'FaceColor','r');
      daspect([1,1,1]);
      text(Bnode(t).j,Bnode(t).i,num2str(t),'HorizontalAlignment','center',...
         'FontWeight','bold','color',[0 0 0]);
   end   
end









