%convert bmp format ms paint networks to matrix representations
%function [Inc,K,C,A,edge] = bmp2a(img,n,m) %n boundary nodes, m interior (optional)
function [Inc,K,C,A,edge] = bmp2a(img,n,m) %n boundary nodes, m interior (optional) 

%preprocesses image
f = pre(img);
drawnow;

if (nargin == 1)
   n = [];
   m = [];
end

if (nargin == 2)
   m = [];
end

%find boundary nodes (really helps to have n)
if (~isempty(n))
   [Bnode,r,ntot] = Bnodes(f,n);
else
   [Bnode,r,ntot] = Bnodes(f); %not robust
end

%find interior nodes
if (~isempty(m))
   [Inode,w] = Inodes(f,Bnode,r,m);
else
   [Inode,w] = Inodes(f,Bnode,r); %OK
end
drawnow; %if things look bad here, might as well quit

%finds the edges and incidence matrix
[Inc,edge] = edges(f,Bnode,Inode,r,w);

%Kirchhoff matrix, conductances and edge-node adjacency matrix
[K,C,A] = getmat(Inc,edge);

%Note that K = A'*C*A