%read image and preprocess
function g = pre(im)

thr = .42;
buf = 40; %buffer around image

f = double(imread(im));

%get size and make grayscale
if (length(size(f))==2)
   [M,N] = size(f);
elseif (length(size(f))==3)
   f = f(:,:,1);
   [M,N] = size(f);
else
   disp('incorrect image size');
end

h = ones(M+2*buf,N+2*buf);
h(buf+1:buf+M,buf+1:buf+N) = f/max(max(f));

%threshold to get binary image
g = (h<thr);

%visualization
figure(42)
colormap gray
axis ij
axis off
imagesc(1-g);
drawnow;


